# -*- coding: UTF-8 -*-
#----------------------------------------
#■ N巴の食物連鎖(food chain of N cycles)
#----------------------------------------
from tkinter import *
from tkinter import messagebox
import random
import math
import time
#■配列として用いるリスト宣言
def array(N1, N2=0, N3=0):
    if N2 == 0 and N3==0:
        return [0 for i in range(N1)]
    elif N3 == 0:
        return [[0 for i in range(N2)] for j in range(N1)]
    else:
        return [[[0 for i in range(N3)] for j in range(N2)] for k in range(N1)]
#■共通データ
MAX = 101   # セル数+1
MD  = 8     # 生物種類数
EP  = 0.5   #  敵に食べられる確率。EP=1にすると幾何学模様に近くなる。
dt=array(2,MAX+1,MAX+1)     # 計算用セルデータ
#         0         1         2         3
cTab=("#FF0000","#0000FF","#FFFF00","#FF00FF",
      "#FFFFFF","#007755","#FF7700","#770077",
      "#770000","#000077","#777700","#007700",
      "#777777","#00FF77","#FF77FF","#FF0077")

hist=array(201)             # 履歴格納用配列
avg4=array(201)             # 20回平均格納用
dspArea=array(MAX+1,MAX+1)  # 表示セル用配列
MAXMAX=(MAX-1)*(MAX-1)      # 全体個体数
avrN=MAXMAX/MD              # 平均個体数
avLine=MAXMAX/40+30         # グラフ表示平均位置         
cur=0                       # 現在のセルを示す
Vline=199                   # 200回毎のグラフ位置を示す縦線の位置
for i in range(MAX+1):      # 計算用セルデータの初期設定
    for j in range(MAX+1):
        dt[cur][i][j]= int(random.random() * MD + 1)
for i in range(201):        # 履歴、20回平均初期設定
    hist[i]=avrN;avg4[i]=avrN
#■個体数をグラフ表示する生物1の個体数のカウント
def count1():
    C=0
    for i in range(MAX):
        for j in range(MAX):
            if dt[cur][i][j]==1: C+=1
    return C
#■履歴データ設定
def setHist(V):             
    for i in range(1,200):
              hist[i-1]=hist[i]; avg4[i-1]=avg4[i]
    hist[199]=V 	    # 値の登録
    av=0		    # 過去20回の平均値計算と平均値登録
    j=199
    for i in range(20): av+=hist[j]; j-=1
    avg4[199]= int(float(av)/20.0+0.5)
#■グラフ表示用XY座標設定    
def setHistXY(hist, i): 
    global avrN, avLine
    return [i+20, avLine-(hist[i]-avrN)/50]
#■最初の表示
def initDraw():
    global canvas, MAX,HSgraph, AVgraph, Vline, VlineX,txtDsp
    canvas.delete("DT")
    for i in range(1,MAX):
        for j in range(1,MAX):
            X=i*2+20; Y=j*2+10
            dspArea[i][j]=canvas.create_rectangle(X, Y, X+2, Y+2,
                                                  fill=cTab[dt[cur][i][j]-1],
                                                  outline="", tag="DT")
    # 生物1の個体数変化の表示
    V=count1(); setHist(V)
    canvas.create_rectangle(20,220,220,340,fill="#FFFFFF",
                            outline='black',width=2, tag="DT")
    # 過去4回平均
    XY=[]
    for i in range(200): XY.append(setHistXY(avg4, i))
    AVgraph=canvas.create_line(XY, fill="#007700", tag="DT")
  
    # 履歴表示
    XY=[]
    for i in range(200): XY.append(setHistXY(hist, i))
    HSgraph=canvas.create_line(XY, fill=cTab[0], tag="DT")
    
    # 3,000, 5,000, 7,000の線を表示
    canvas.create_line(20,320,220,320, fill="#000077", tag="DT")
    canvas.create_line(20,280,220,280, fill="#000077", tag="DT")
    canvas.create_line(20,240,220,240, fill="#000077", tag="DT")
    VlineX = canvas.create_line(Vline+20,240,Vline+20, 340,
                                fill="#000077", tag="DT")
    Vline-=1
    if Vline<0 : Vline=199
        
    # 数値表示
    S="%d 個体数変化(赤) 20回平均(緑) %d" % (V, avg4[199])
    txtDsp=canvas.create_text(120, 230, text=S,
                              font=('sans-serif', '8'), tag="DT")
#■2回目以降のセル表示(セルの色変更)
def draw():
    global canvas, MAX,HSgraph, AVgraph, Vline, VlineX,txtDsp
    for i in range(1,MAX):
        for j in range(1,MAX):
            X=i+20; Y=j+10
            CC=cTab[dt[cur][i][j]-1] # 以下の1行の判定でかなり速くなる
            if CC != canvas.itemcget(dspArea[i][j], option='fill'):
                canvas.itemconfig(dspArea[i][j], fill=CC)
            j+=1
        i+=1
#■2回目以降のグラフ表示(表示が変わる部分のみ）
def drawGraph():
    global canvas, MAX,HSgraph, AVgraph, Vline, VlineX,txtDsp
    V=count1(); setHist(V)
    # 過去4回平均
    XY=[]
    for i in range(200): XY.append(setHistXY(avg4, i))
    canvas.delete(AVgraph)
    AVgraph=canvas.create_line(XY, fill="#007700", tag="DT")
    # 履歴表示
    XY=[]
    for i in range(200): XY.append(setHistXY(hist, i))
    canvas.delete(HSgraph)
    HSgraph=canvas.create_line(XY, fill=cTab[0], tag="DT")
    #区切り
    canvas.coords(VlineX, Vline+20,240,Vline+20, 340)
    Vline-=1
    if Vline<0 : Vline=199
    # 数値表示
    S="%d 個体数変化(赤) 20回平均(緑) %d" % (V, avg4[199])
    canvas.itemconfig(txtDsp, text=S)
#■食物連鎖のシミュレーション    
def simChain():
    global cur
    nxt=1-cur
    for i in range(1,MAX):
        for j in range(1,MAX):
            dt[nxt][i][j]=dt[cur][i][j]
            if random.random()< EP : 
                for k in range(1,MD+1):
                    KF = k + 1
                    if k== MD: KF = 1
                    if dt[cur][i][j]==k :
                        
                        if(dt[cur][i  ][j-1]==KF or dt[cur][i  ][j+1]==KF or
                           dt[cur][i-1][j ]==KF or dt[cur][i+1][j  ]==KF) :
                            dt[nxt][i][j]=KF
                        #　判定を以下のようにすると若干趣が変わります。
                        #if(dt[cur][i][j-1]==KF or dt[cur][i][j+1]==KF or
                        #   dt[cur][i-1][j]==KF or dt[cur][i+1][j]==KF or
                        #   dt[cur][i-1][j-1]==KF or dt[cur][i+1][j-1]==KF or
		        #   dt[cur][i-1][j+1]==KF or dt[cur][i+1][j+1]==KF):
                        #    dt[nxt][i][j]=KF
    cur=nxt
#■メイン処理        
root=Tk()
root.title("N巴の食物連鎖(N= %d)" % MD )
canvas=Canvas(root, width=260,height=400,bg="white")
canvas.pack()
simChain();initDraw()
root.update()
while True:
    simChain(); draw()
    drawGraph()
    time.sleep(0.01)
    root.update()

